<?php
// HTTP POST送信された写真を保存
$uploads = array();
if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    for ($i = 0; $i < count(@$_POST["kaito_img"]); $i++){
        $jpeg = base64_decode(@$_POST["kaito_img"][$i]);
        $path = "/var/tmp/kaito_img".$i.".jpg";
        // 指定パスに保存
        file_put_contents($path, $jpeg);
        // 保存された写真を削除
        unlink($path);
        $uploads[] = $path;
    }
}
?>
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta content="width=device-width,initial-scale=1.0" name="viewport">
    <title></title>
    <link rel="stylesheet" href="./css/skyblue.css">
    <link rel="stylesheet" href="./css/main.css">
    <script src="./js/jquery-3.3.1.min.js" type="text/javascript" charset="utf-8"></script>
</head>
<body>
    <nav class="nav-bar">
        <div class="xs-3 margin-x-10">
            <img src="./img/logo_jmas_blue.jpg" alt="logo" class="nav-logo">
        </div>
    </nav>
    <div class="container">
        <!-- iOS KAITOブラウザ用コンテンツ -->
        <div id="ios-page" style="display: none;">
            <div class="camera xs-12">
                <div class="title">
                    <p class="bold title-name">カメラ</p>
                    <hr class="separater">
                </div>
                <div class="content xs-12 padding-x-10">
                    <!-- カメラ設定 -->
                    <div class="xs-12 padding-top-10">
                        <p id="setting" class="bold">カメラ設定</p>
                        <div class="form-list" style="display: none;">
                            <!-- 撮影枚数上限 -->
                            <div class="form-item xs-12 margin-bottom-15">
                                <p class="form-name">撮影可能枚数</p>
                                <div class="camera-setting-text xs-12">
                                    <input id="limit" class="xs-3" type="text" name="limit" value="10" placeholder="">
                                </div>
                            </div>
                            <!-- 撮影画像サイズ指定 -->
                            <div class="form-item xs-12 margin-bottom-15">
                                <p class="form-name">撮影サイズ</p>
                                <div class="camera-setting-radio xs-12">
                                    <input type="radio" name="size" id="size-0" value="0" checked="">
                                    <label for="size-0" class="xs-3">最高</label>
                                    <input type="radio" name="size" id="size-1" value="1">
                                    <label for="size-1" class="xs-3">高</label>
                                    <input type="radio" name="size" id="size-2" value="2">
                                    <label for="size-2" class="xs-3">普通</label>
                                    <input type="radio" name="size" id="size-3" value="3">
                                    <label for="size-3" class="xs-3">低</label>
                                </div>
                            </div>
                            <!-- 位置情報 -->
                            <div class="form-item xs-12 margin-bottom-15">
                                <p class="form-name">位置情報</p>
                                <div class="camera-setting-radio xs-12">
                                    <input type="radio" name="geolocation" id="geolocation-0" value="0" checked="">
                                    <label for="geolocation-0" class="xs-3">無効</label>
                                    <input type="radio" name="geolocation" id="geolocation-1" value="1">
                                    <label for="geolocation-1" class="xs-3">有効</label>
                                </div>
                            </div>
                            <!-- 日付打刻 -->
                            <div class="form-item xs-12 margin-bottom-15">
                                <p class="form-name">日付打刻</p>
                                <div class="camera-setting-radio xs-12">
                                    <input type="radio" name="time" id="time-0" value="0" checked="">
                                    <label for="time-0" class="xs-3">無効</label>
                                    <input type="radio" name="time" id="time-1" value="1">
                                    <label for="time-1" class="xs-3">有効</label>
                                </div>
                            </div>
                            <!-- グリッド表示 -->
                            <div class="form-item xs-12 margin-bottom-15">
                                <p class="form-name">グリッド表示</p>
                                <div class="camera-setting-radio xs-12">
                                    <input type="radio" name="grid" id="grid-0" value="0" checked="">
                                    <label for="grid-0" class="xs-3">無効</label>
                                    <input type="radio" name="grid" id="grid-1" value="1">
                                    <label for="grid-1" class="xs-3">有効</label>
                                </div>
                            </div>
                            <!-- 画像編集 -->
                            <div class="form-item xs-12 margin-bottom-15">
                                <p class="form-name">画像編集</p>
                                <div class="camera-setting-radio xs-12">
                                    <input type="radio" name="edit" id="edit-0" value="0" checked="">
                                    <label for="edit-0" class="xs-3">無効</label>
                                    <input type="radio" name="edit" id="edit-1" value="1">
                                    <label for="edit-1" class="xs-3">有効</label>
                                </div>
                            </div>
                            <!-- 画像補正 -->
                            <div class="form-item xs-12 margin-bottom-15">
                                <p class="form-name">画像補正</p>
                                <div class="camera-setting-radio xs-12">
                                    <input type="radio" name="correction" id="correction-0" value="0" checked="">
                                    <label for="correction-0" class="xs-3">無効</label>
                                    <input type="radio" name="correction" id="correction-1" value="1">
                                    <label for="correction-1" class="xs-3">有効</label>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- 撮影開始ボタン -->
                    <div class="text-center xs-12 padding-top-20">
                        <img id="camera" class="camera-icon" src="./img/icon.png" alt="icon">
                    </div>
                </div>
            </div>
            <!-- 撮影結果 -->
            <div class="result xs-12 padding-top-30 padding-bottom-30">
                <div class="title">
                    <p class="bold title-name">撮影結果</p>
                    <hr class="separater">
                </div>
                <div class="content xs-12 padding-x-10">
                    <div>
                        <p class="send-item">撮影枚数：<span id="photo-count">-</span></p>
                    </div>
                    <!-- 撮影写真表示 -->
                    <div id="photos" class="photos xs-12 row-eq-height">
                    </div>
                    <!-- 送信ボタン -->
                    <div class="submit xs-12 padding-top-10">
                        <div class="text-center xs-12">
                            <form method="POST" action="camera.php">
                                <!-- 撮影結果の写真は以下のタグに追加されます。 -->
                                <div id="kaito_camera">
                                </div>
                                <input type="submit" class="send-btn" value="送信" />
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <!-- 送信結果 -->
            <div class="result xs-12 padding-top-30 padding-bottom-30">
                <div class="title">
                    <p class="bold title-name">送信結果</p>
                    <hr class="separater">
                </div>
                <div class="content xs-12 padding-x-10">
                    <!-- 送信結果 -->
                    <div id="send-result" class="send-list xs-12 padding-top-10">
                        <?php if (count($uploads) > 0) { ?>
                        <p class="send-item">送信結果：正常終了</p>
                        <p class="send-item">送信枚数：<?php echo count($uploads) ?>枚</p>
                        <div class="padding-left-10">
                            <p class="send-text">※送信されたファイルは自動的に削除されます。</p>
                        </div>
                        <?php } else { ?>
                        <p class="send-item">送信結果：-</p>
                        <?php } ?>
                    </div>
                </div>
            </div>
        </div>
        <div id="another-page" class="text-center padding-top-30" style="display: none;">
            <h5 class="bold">iOS版のKAITOで<br>アクセスしてください</h5>
        </div>
    </div>
    <div class="dialog-back text-center" id="dialog-back">
        <div class="dialog" id="dialog">
            <div class="dialog-content">
                <p id="dialog-message" class="margin-bottom-10"></p>
                <p id="dialog-detail"></p>
            </div>
            <div class="dialog-content text-center">
                <button type="button" class="dialog-close">閉じる</button>
            </div>
        </div>
    </div>
    <footer class="footer text-center">
        <p class="copyright">Copyright©2019 JMA Systems Corporation</p>
    </footer>
</body>
<script type="text/javascript">
$(document).ready(function () {
    // カメラ起動ボタンクリック
    $("#camera").on('click', function() {
        // カメラオプション関数呼び出し
        exec_kaito_camera();
    });

    // カメラ設定クリック
    $("#setting").click(function () {
        $(this).toggleClass("open");
        $(this).next().slideToggle(500);
    });

    // ダイアログ > 閉じるボタンクリック
    $(".dialog-close").on("click", function(){
        $(this).parents(".dialog").hide();
        $("#dialog-back").hide();
    });

    // KAITOブラウザ判定
    var ua = window.navigator.userAgent.toLowerCase();
    if( (ua.indexOf("iphone") !== -1 || ua.indexOf("ipad") !== -1) && ua.indexOf("kaito") !== -1 ) {
        $("#ios-page").show();
        $("#another-page").hide();
    } else {
        $("#ios-page").hide();
        $("#another-page").show();
    }

    $('#limit').on('focus', function(){
        $(".nav-bar").css("position", "absolute");
        $(".nav-bar").css("width", "100vw");
    });
    $('#limit').on('blur', function(){
        $(".nav-bar").css("position", "fixed");
    });
});

/**
 * カメラオプション起動関数を実行します.
 */
function exec_kaito_camera() {
    //
    // カメラオプションで利用可能な機能を作成します.
    //
    var options = {};

    // 撮影枚数上限
    options['limit'] = Number($('div.camera-setting-text>input[name="limit"]').val());

    // 日付打刻
    options['time'] = Number($('div.camera-setting-radio>input[name="time"]:checked').val());

    // 撮影画像サイズ指定
    options['size'] = Number($('div.camera-setting-radio>input[name="size"]:checked').val());

    // グリッド表示
    options['grid'] = Number($('div.camera-setting-radio>input[name="grid"]:checked').val());

    // 画像編集
    options['edit'] = Number($('div.camera-setting-radio>input[name="edit"]:checked').val());

    // 画像補正
    options['correction'] = Number($('div.camera-setting-radio>input[name="correction"]:checked').val());

    // 位置情報
    options['geolocation'] = Number($('div.camera-setting-radio>input[name="geolocation"]:checked').val());

    //
    // カメラオプション起動関数を実行します.
    //
    jp_co_jmas_camera(callback_kaito_camera, options);
}

/**
 * カメラオプション起動関数での撮影完了後に実行されるコールバック関数.
 */
function callback_kaito_camera(results) {

    // カメラオプション起動関数の実行結果を判定
    if (results.result == 0) {
        //
        // 0:成功
        //

        // 撮影した写真をサムネイル表示
        $('#photos').empty();
        $('#kaito_camera>input[name^="kaito_img"]').each(function(index, element) {
            $('<img>', {
                src: 'data:image/jpeg;base64,' + $(element).val(),
                class: 'xs-6 padding-10',
            }).appendTo('#photos');
        });

        // 撮影枚数を設定
        photo_count = results.count;
        if (photo_count == 0) {
            $('#photo-count').text('-');
        } else {
            $('#photo-count').text(photo_count + '枚');
        }
    } else {
        switch (results.result) {
            //
            // -1:カメラ機能抑止
            //
            case -1:
                $('#dialog-message').text("端末のカメラ機能が利用できない状態のため、カメラオプションの起動に失敗しました。");
                $('#dialog-detail').text("端末のカメラ機能を有効にしてください。");
                break;

            //
            // -2:位置情報機能抑止
            //
            case -2:
                $('#dialog-message').text("端末の位置情報が利用できない状態のため、カメラオプションの起動に失敗しました。");
                $('#dialog-detail').text("端末の位置情報機能を有効にしてください。");
                break;

            //
            // -3:不正データ
            //
            case -3:
                $('#dialog-message').text("Web コンテンツ内の name 属性「kaito_img」に不正なフォーマットのデータが設定されているため、カメラオプションの起動に失敗しました。");
                $('#dialog-detail').text("「kaito_img」に設定されている値をクリアしてください。");
                break;

            //
            // -4:タグ不正
            //
            case -4:
                $('#dialog-message').text("Web コンテンツ内に id 属性「kaito_camera」の要素が存在しないため、カメラオプションの起動に失敗しました。");
                $('#dialog-detail').text("Web コンテンツをご確認ください。");
                break;

            //
            // -99:システムエラー
            //
            case -99:
                $('#dialog-message').text("システムエラーが発生しています。");
                $('#dialog-detail').text(results.detail);
                break;
        }
        //leftの値 = (ウィンドウ幅 -コンテンツ幅) ÷ 2
        var leftPosition = (($(window).width() - $("#dialog").outerWidth(true)) / 2);
        //CSSを変更
        $("#dialog").css({"left": leftPosition + "px"});
        $('#dialog').show();
        $('#dialog-back').show();
    }
}
</script>
</html>
